int get_num(void)
{
//090206 07:35 get_num ver2.7

	int post_num=0;	/*ポスト番号*/
	int i,j,k=0;		/*判定に使用するカウンタ*/
	char get_post='e';	/*エラー検出に使用*/
	char got_ws[4];	/*白線センサの値を固定*/
	int ts_search=0;	/*タッチセンサが見付からない場合の対応*/

	printf("\nstart moving");

	//03:14
	/*straight200[mm]->turnleft180[deg]->back50[mm]*/
	printf("\n straight_200[mm],1000[msec]\n");
	lqr_straight(200,1000);
	usleep(300000);
	usleep(1000000);
	printf("\n turnright_180[deg],3600[msec]\n");
	lqr_rotate(-LQR_DEG,RORT_TIME);
	usleep(300000);
	usleep(RORT_TIME*1000);
	pwm_both_data(0,0);
	pwm_enco_start(10);
	usleep(20000);
	printf("\n back_100[mm],800[msec]\n");
	pwm_lqr_straight(-100,500);
	count.br=0;
	//動作終了フラグ

	/*後退中touch_sensorを常にcheck*/
	while(count.br==0){
		usleep(20000);
		if(ts[BACK_TS]=='1'){
			usleep(300000);
			//tire stop
			pwm_both_data(0,0);
			usleep(20000);
			//stop encoder task
			printf("\n Stop encoder task.\n");
			pwm_enco_stop();
			usleep(20000);
			break;
		}
		if(count.br==1 && ts_search!=7) {
			//tire stop
			pwm_both_data(0,0);
			usleep(20000);
			pwm_enco_stop();
			usleep(20000);
			printf("\n***********TS was not detected.***********\n\n");
			pwm_both_data(0,0);
			pwm_enco_start(10);
			usleep(20000);
			if(ts_search==0){
				ts_search=1;
				pwm_lqr_rotate(10,150);
				usleep(20000);
				count.br=0;
			}else if(ts_search==1){
				ts_search=2;
				pwm_lqr_rotate(-20,300);
				usleep(20000);
				count.br=0;
			}else if(ts_search==2){
				ts_search=3;
				pwm_lqr_straight(-10,100);
				usleep(20000);
				count.br=0;
			}else if(ts_search=3){
				ts_search=4;
				pwm_lqr_rotate(20,300);
				usleep(20000);
				count.br=0;
			}else if(ts_search==4){
				ts_search=5;
				pwm_lqr_straight(-10,100);
				usleep(20000);
				count.br=0;
			}else if(ts_search==5){
				ts_search=6;
				pwm_lqr_rotate(-10,150);
				usleep(20000);
				count.br=0;
			}else if(ts_search==6){
				k=CHECK_LOOP+1;
				ts_search=7;
				pwm_lqr_straight(10,100);
				usleep(20000);
				count.br=0;
			}
		}else if(count.br==1 && ts_search==7){
			//tire stop
			pwm_both_data(0,0);
			usleep(20000);
			pwm_enco_stop();
			usleep(20000);
			k=CHECK_LOOP;
			break;
		}
	}


/*
psition of white sensor
     POST
|||||||||||||||
|             |no signal:post number=1
|||||||||||||||
|             |>ws[3]:post number=2
|||||||||||||||
|             |>ws[2]:post number=3
|||||||||||||||
|             |>ws[1]:post number=4
|||||||||||||||
|             |>ws[0]:post number=5
|||||||||||||||
|||||||||||||||
*/

/*判定の手順
1.ws[3]から順に値を参照して、始めに白を見付けた位置より下
　のwsが全て白を見付けていたら該当するポスト番号とする。
　始めに白を見付けた位置より下のwsが白を見付けられなけれ
　ばエラー。
　CHECK_LOOP回までリトライする。
2.1でポスト番号を獲得できなかった場合、一番上の白のみでポス
　ト番号を判断する。
　判断した番号が既にポスト構造体のcodeに登録されていた場合ときは
　取得を失敗する。
3.1,2でポスト番号を獲得できなかった場合、ポスト構造体のcodeに登録
　されていないポスト番号をPOST_NUM番から順に割り当てる。

1でポスト番号を獲得できた場合、この番号の信頼度をtrust_level1とす
る。同様に、手順2,3でポスト番号を獲得した場合は、trust_level2,3と
する。信頼度はtrust_level1>2>3の順で高い。
獲得したポスト番号が以前獲得したものと重複した場合、trust_levelの
高いものを正しいと判断し、該当ポストの番号には未取得のものを割り
当てる。これで割り当てられた番号の信頼度はtrust_level3とする。
*/

//*ここから判定部分======================
	printf("\n start get num\n");
	while(get_post=='e' && k<=CHECK_LOOP){
	printf("level1_start\n");
	printf("\n\nnow_%dnd_loop\n\n",k);
	//errorあるときCHECK_LOOP回までrepeat
		usleep(GET_TIME);
		//センサ値の更新
		k++;
		//終わらないと恐いのであきらめるためのcounter
		get_post='n';
		//error判定初期化
		for(i=0;i<=3;i++){got_ws[i]=ws[i];}
		//wsの値をfix
		printf("level1_initialize\n");
		for(j=(POST_NUM-2);j>=0;j--){
			if(got_ws[j]!=KURO){
			//ws[j]=白
				for(i=POST_NUM-2;i>=j+1;i--){
					if(got_ws[i]==KURO){
						get_post='e';
						printf("e.");
					}
					printf("/n");
					//ws[j]以外が黒=error
				}
				if(get_post!='e' && trust_level[j+2]!=1){
					post_num=j+2;
					printf("post_num=%d\n",post_num);
				}
				//エラー無し=j+2番post
			}else{post_num=POST_NUM;}
			//wsが全て黒=POST_NUM番post
		}
	}

	if(trust_level[post_num]>=2){
	//重複番号修正
		printf("repairing_number\n");
		printf("pert 1\n");
		for(k=0;k<=POST_NUM;k++){
			if(post.code[k]==post_num){
				post.code[k]=0;
				break;
			}
		}
		printf("pert 2\n");
		i=POST_NUM+1;
		while(post.code[k]==0){
			i--;
			for(j=0;j<POST_NUM;j++){
				if(post.code[j]!=i && post.code[j]!=post_num){
					break;
				}else{
					post.code[k]=i;
					break;
				}
			}
		}
		trust_level[i]=3;
	}

	if(post_num=POST_NUM){
		trust_level[post_num]=3;
	}else{
		trust_level[post_num]=1;
	}
	//errorなしでpost_get成功=level1
	//level1=信頼度max

	if(get_post!='e' && post_num!=0){
	//errorあるまま終了した場合の処理
		printf("level2_start\n");
		if(got_ws[j]!=KURO){
			for(i=0;i<POST_NUM;i++){
				if(post.code[i]==j+2){break;}
				else if(trust_level[j+2]>2){post_num=j+2;}
			}
			//(ws[j]=白 and j+2番postを未取得)=j+2番post
		}else{
			for(i=0;i<POST_NUM;i++){
				if(post.code[i]==POST_NUM){break;}
				else if(trust_level[POST_NUM]>2){post_num=POST_NUM;}
			}
			//(全ws=黒 and POST_NUM番postを未取得)=POST_NUM番post
		}
		if(trust_level[post_num]>2){//重複番号修正
			printf("repairing_number\n");
			for(k=0;k<=POST_NUM;k++){
				if(post.code[k]==post_num){
					post.code[k]=0;
					break;
				}
			}
			i=POST_NUM+1;
			while(post.code[k]==0){
				i--;
				for(j=0;j<POST_NUM;j++){
					if(post.code[j]!=i && post.code[j]!=post_num){
						break;
					}else{
						post.code[k]=i;
						break;
					}
				}
			}
			trust_level[i]=3;
		}
		if(post_num=POST_NUM){
			trust_level[post_num]=3;
		}else if(post_num!=0){
			trust_level[post_num]=2;
			//level2=信頼度mid
		}
	}

	if(get_post=='e' && post_num!=0){
	}else if(post_num==0){
		printf("level3_start\n");
		i=POST_NUM+1;
		while(post_num==0){
			i--;
			for(j=0;j<POST_NUM;j++){
				if(post.code[j]!=i){
					post_num=0;
					break;
				}else{post_num=i;}
			}
		}
		trust_level[post_num]=3;
	}

//ここまで判定部分=======================*/

	printf("\n--the post is seen by mirs--");
	printf("\n|||||||||||||||");
	printf("\n|             |");
	printf("\n|||||||||||||||");
	for(i=3;i>=0;i--){
		if(got_ws[i]==KURO){
			printf("\n|             |");
		}else{
			printf("\n|||||||||||||||");
		}
	printf("<= ws[%d]=%c",i,got_ws[i]);
	printf("\n|||||||||||||||");
	}
	printf("\n|||||||||||||||");
	printf("\n|||||||||||||||");
	printf("\n|||||||||||||||");
	printf("\npost number = %d",post_num);
	printf("\ntrust_level of got number is %d\n",trust_level[post_num]);
	printf("\nfinish get num\n");


	return post_num;
}
