//approach
/*
This program is based on post_approach of MIRSSTND V1.1 and approach.c of MIRS0401
        2005/5/24
	modified by S. Ushimaru
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

#define PWM_SLEEP 20000
#define TURN_TIME 1300
#define DETECTING_TIME	14000
#define SLEEP_TIME	200000

int post_approach(int target_post){

	int move_time,rotate_time;
	int angle, distance = 0; 
	int r_value=0;
	int p_flag=0;	
/*	int ts_state=1;			ɲá㳰ư*/
	int circle_radious2=circle_radious;	/*ɲá㳰ư*/

	FILE *fplog_pa;
	fplog_pa=fopen("log_post_approach_prototype1.txt","a");

	//chage the post angle data between -180~180
	if(post.ang[target_post]<180){			/*ɸŪΥݥȤγ٤180̤*/
		angle=post.ang[target_post]-180;
	}else{						/*180٥С*/
		angle=post.ang[target_post]-180;
	}
	printf("in approach func. approach angle = %d\n",angle);

     	//rotate at the center
	rotate_time=angle*20;
	lqr_rotate(angle,rotate_time);
	usleep(300000);
	printf("rotation end: correct_direction start \n");

	/*start correct_direction1ư1*/
	p_flag = correct_direction1(target_post);
	
	if(p_flag != -1){/*here is post ݥȯ*/
		//determine the distace to go and move to the post
		distance=uss12 + USS_CORRECT - USS_MIN ;
		printf("in approach func. approach distance = %d\n",distance);
		move_time=distance*4;

		fprintf(fplog_pa,"distance = %d\n",distance);
		fclose(fplog_pa);
		fplog_pa=fopen("log_post_approach_prototype1.txt","a");

		count.br=0;	//⡼ߤ+1
		pwm_both_data(0,0);
		pwm_enco_start(10);

		pwm_lqr_straight(distance,move_time);
		/*ݥܶᳫ	._.
				|P|      (^o^ ) 
		  ιԤ move_time=distance*4; ꡡư֤ϰưΥ4
		  ߤǽΤpwmѹ*/


		//### 㳰ư ###
		/*ܶ˥å󥵤˥å*/
		while(count.br==0){
			if(ts[0] == '1' || ts[2] == '1') {				/*å󥵤ON  :2,:0,:1 Ȥ*/
				printf("\n***********MIRS collided with the post.***********\n\n");	/*ݥȤ˾ͤޤby*/
				printf("Go arround target post\n");	/*򳫻*/
				printf("\n**********Evasion operation started.*********\n\n");	/*㳰()ưϤʤΤ*/
				fprintf(fplog_pa,"\n**********Evasion operation started.*********\n\n");	/*㳰()ưϤʤΤ*/
				usleep(300000);	/*äȥ*/

				lqr_straight(-50,800);			/* 5cm , 0.3sec*/
				count.br=0;
				pwm_both_data(0, 0);
				usleep(20000);
				pwm_enco_start(10);
				pwm_lqr_circle(circle_radious2, -AROUND_ANG,DETECTING_TIME/2);	/*ݥȲȾưž*/

				count.br=0;		/*pwmνλǧѿν*/
				usleep(300000);

				while(1){
					if(count.br==1) {
						/*tire stoppwm潪λǧƱ˥䥹ȥå*/
						pwm_both_data(0,0);
						usleep(PWM_SLEEP);
						pwm_enco_stop();
						usleep(PWM_SLEEP);
						printf("\n***********MIRS stopped.***********\n\n");

						lqr_rotate(90,TURN_TIME);	/*̤*/
						usleep(SLEEP_TIME);

						lqr_straight(distance - ((circle_radious2*2)+50),move_time);
						/*ˤľʤǤʤä;εΥư*/
						usleep(300000);
						printf("\n **********Evasion operation ended.********* \n\n");
						/*ưλǤ*/
						break;
					}
				}
				break;
			}else if(ts[1] == '1'){
				printf("\n***********MIRS collided with the post.***********\n\n");
				printf("Go arround target post\n");	/*򳫻*/
				lqr_straight(-50,3000);			/* 5cm , 0.2sec*/
				usleep(300000);
				pwm_lqr_circle(circle_radious2, AROUND_ANG,DETECTING_TIME/2);	/*ݥȲȾưž*/

				count.br=0;		/*pwmνλǧѿν*/
				usleep(300000);

				while(1){
					if(count.br==1) {
						/*tire stoppwm潪λǧƱ˥䥹ȥå*/
						pwm_both_data(0,0);
						usleep(PWM_SLEEP);
						pwm_enco_stop();
						usleep(PWM_SLEEP);
						printf("\n ***********MIRS stopped.*********** \n\n");

						lqr_rotate(-90,TURN_TIME);	/*̤*/
						usleep(SLEEP_TIME);

						lqr_straight(distance - ((circle_radious2*2)+50),move_time);
						/*ˤľʤǤʤä;εΥư*/
						usleep(300000);
						printf("\n **********Evasion operation ended.********* \n\n");
						/*ưλǤ*/
						break;
					}else{
						usleep(20000);
					}
			
				}
				break;
			}else{
				usleep(20000);
			}
		}
		/*ޤǡʡϡˤ[λ] */
		pwm_both_data(0, 0);	/*󥳡ư*/
		usleep(20000);
		pwm_enco_stop();
		usleep(20000);

		printf("### Post approach complete ! ###\n");

		//exit(0);
       
		/*move to the point of circe_radius	Ⱦ¤ؤΰưưǤɬפʤ*/
//		circle_position(); 
//		usleep(300000);

		//determine return distance
		printf("return_dist = %d, target_post = %d, circle_radious = %d\n",return_dist,target_post,circle_radious);
		return_dist=post.dis[target_post]-circle_radious;
		printf("return_dist = %d, target_post = %d, circle_radious = %d\n",return_dist,target_post,circle_radious);

		//determine the return value
		r_value = 0;
	}else{/*there is no post ݥȤǧǤޤؤ󤬤*/
		printf("There is no post!\n");
		r_value = 9999;
	}

	fclose(fplog_pa);

	return r_value;
}
