#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int main()
{
	/*
	center_count : count of center postion
	target_post  : post number selected by post_select()
		"post number" means seaquencial number of posts found in post_search()
	target_code  : IRS code of the post to get now
		This variable is defined as gloabl varialble.
	*/
	int center_count=0;
	int center_corr_count=0;
//	int target_post;
	int target_post=0;
	int ret;
	int search_retry, search_result=-1;
	int i;
	FILE *fp;

	fp=fopen("post_data.txt","w");
	post.got_number=0;

	printf("Initialize\n");
	ret=initialize();

//////////

	pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);

	printf("Post search 1st Try\n");

	printf("Searched post number =%d\n",post.number);
	while(post.number!=POST_NUM){					//全部のポスト発見まで
       		usleep(300000);						//Г"usleep"の間隔で まいくろすりーぷ
		post_search_0(1);					//Ｌポスト探索を行う
		printf("Searched post number =%d\n",post.number);
		if(post.number >= POST_NUM){				//総ポスト以上発見したら
			post_check(1);					//ポストチェック開始
			printf("Searched post number after post_check=%d\n",post.number);
		}
	}
	pthread_cancel(uss_task);

////////////

END:

	usleep(300000);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);
	printf("All posts have been got\n");
	printf("Original Post postion\n");
	fprintf(fp,"Original Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
	}
	printf("Tempral Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
	}

	// close all device file 
        close(fd0);
        close(fd1);
        close(fd2);
        close(fd3);
        //close(fd4);
        close(fd5);
        //close(fd6);
        //close(fd7);
        close(ctl);
        fclose(fp);
        return 0;
}
